#include "stdafx.h"
#include "math.h"
#include "SWF.h"

//TODO - are bitmap storage widths a mult of 8 ? 

void ZLibCompress( BYTE * p, int iLen, CString * pc ) { 
	
	// [Header] 
	// any number of [0,i2byteLen,~i2byteLen,data]
	// a single [1,i2byteLen,~i2byteLen,data]
	// followed by adler32 checksum for all data bytes 

	//TODO - real compression
	
	int iByte,iS1=1,iS2=0;			// adler32 checksum
	
	pc->Set( "\x78\xDA", 2 );
	
	//-- add blocks of 32 k till length is less than 32 k
	while( iLen > 32000 ) { 
		//-- Leader : chr(128) (more data), (short) length=32000; 
		//-- short(ones complement length) : 
		//-- chr(128) short(32000=0x7d00) short(!32000=0x82FF) (reverse byte ordering)
		pc->Append( "\x00\x00\x7D\xFF\x82", 5 );		

		//-- Adler32 checksum
		for( iByte=0; iByte<32000; ++iByte ) {
			iS1=(iS1+p[iByte])%65521;
			iS2=(iS2+iS1)%65521;
			}

		//-- Data 
		pc->Append( (char *)p, 32000 );
		p+=32000;
		iLen-=32000;
		}
	
	//-- add final block - < 32 k 
	short i = iLen;
	short i1 = ~i;
	char ach[5]={ 1,iLen%256,iLen/256,i1%256,i1/256};
	pc->Append( ach, 5 );		
	pc->Append( (char *)p, iLen );
	
	//-- Adler32 checksum
	for( i=0; i<iLen; ++i ) {
		iS1=(iS1+p[i])%65521;
		iS2=(iS2+iS1)%65521;
		}
		
	//-- add checksum - note unusual byte order 
	pc->Append( iS2/256 );
	pc->Append( iS2%256 );
	pc->Append( iS1/256 );
	pc->Append( iS1%256 );
	}

//--------------------------------------------------------------------- CBitBin
//---- create bitbin que 
CBitBin :: CBitBin( int iLen ) { 
	m_iBit=0;
	m_pBuf = new BYTE[m_iLen=iLen];
	if( m_pBuf != NULL )
		memset( m_pBuf, 0, iLen );
	}

// check / reallocate m_pBuf so at least iLen free space exists
void CBitBin :: EnsureSpace( int iLen ){
	if( m_iBit/8+1+iLen >= m_iLen ) { 
		BYTE * temp = new BYTE[m_iLen+iLen+BINSIZE];
		memcpy( temp, m_pBuf, m_iLen );
		memset( temp+m_iLen, 0, iLen+BINSIZE );
		m_iLen+=iLen+BINSIZE;
		m_pBuf=temp;
		}
	}

//---- empty Queue by setting used counter to 0 			
void CBitBin :: ClearQue() { 
	m_iBit=0; 
	}

//---- Move bit ptr to start of next BYTE 
void CBitBin :: FlushChar( ){
	if( m_iBit%8 != 0 ) { 
		EnsureSpace(1);
		m_iBit+=(8-(m_iBit%8));
		}
	}

//---- add a single bit to queue 
void CBitBin :: PushBit( bool b ) { 
	EnsureSpace(1);
	if( b ) 
		m_pBuf[m_iBit/8] |= (128>>(m_iBit%8));
	++m_iBit;
	}

//---- add int represented in iBits bits to que		
void CBitBin :: PushInt( int i, int iBits ) { 
	while( --iBits>=0 ) 
		PushBit( 0!= (i&(1<<iBits)) );
	}
	
//---- add short in lsb, msb order 
void CBitBin :: PushShort( short i ) { 
	PushBYTE( *((BYTE *)(&i)) );
	PushBYTE( *( ((BYTE *)(&i))+1 ) );
	}

//---- add int32 in lsb, msb order 
void CBitBin :: PushLong( int i ) { 
	PushBYTE( *((BYTE *)(&i)) );
	PushBYTE( *( ((BYTE *)(&i))+1 ) );
	PushBYTE( *( ((BYTE *)(&i))+2 ) );
	PushBYTE( *( ((BYTE *)(&i))+3 ) );
	}

//---- add float represented in iBits mantissa + 16 bits fraction  ( FltToBin ) 
void CBitBin :: PushDbl( double d, int iBits ) {
	int iM = int(d);
	PushInt( iM, iBits );
	PushInt( int((d-iM)*65536), 16 );
    }

//-- Create SWF rectangle string : 1st 5 bits are number of bits for each subsequent
//-- value.  Followed by x0,x1,y0,y1 and padded with 0's to byte length.
void CBitBin :: PushRct( int iBits, int ix0, int ix1, int iy0, int iy1 ) {
    if( iBits==0 ) {
		int iMax = max( max( ix0, ix1 ), max( iy0, iy1 ) );
		++iBits;
		while( iMax>0 ) {
			++iBits;
			iMax=(iMax>>1);
			}
		}
	PushInt( iBits, 5 );
    PushInt( ix0, iBits );
    PushInt( ix1, iBits );
    PushInt( iy0, iBits );
    PushInt( iy1, iBits );
    }

//----- Add SQF matrix to que 
void CBitBin :: PushMtx( double dXScale, double dYScale, double dXSkew, double dYSkew, int iXTranslate, int iYTranslate ) { 
	int iBits;
	
	//-- scale factors
	if( dXScale == -1.0 ) 
		PushBit(false);
	else {
		PushBit(true);
        iBits=int(ceil(log2(max(dXScale*20.0,dYScale*20.0))))+1;
        PushInt( iBits+16, 5 );
        PushDbl( dXScale*20.0, iBits );
        PushDbl( dYScale*20.0, iBits );
        }

	//-- skew factors
    if( dXSkew==-1.0 ) 
		PushBit(false);
	else {
		PushBit(true);

        iBits=int(ceil(log2(max(dXSkew,dYSkew))))+1;
        PushInt( iBits+16, 5 );
        PushDbl( dXSkew, iBits );
        PushDbl( dYSkew, iBits );
		}
		
	//-- translation factors
    if( iXTranslate==-1.0 ) 
		PushInt( 0, 5);
	else {
        iBits=int(ceil(log2(double(max(iXTranslate*20.0,iYTranslate*20.0)))))+1;
        PushInt( iBits, 5 );
        PushInt( iXTranslate*20, iBits );
        PushInt( iXTranslate*20, iBits );
		}
	}

//-- add a color to the que 
void CBitBin :: PushRGB( BYTE r, BYTE g, BYTE b ) { 
	PushInt( b, 8 );
	PushInt( g, 8 );
	PushInt( r, 8 );
	}
void CBitBin :: PushRGBA( BYTE r, BYTE g, BYTE b, BYTE a ) { 
	PushInt( b, 8 );
	PushInt( g, 8 );
	PushInt( r, 8 );
	PushInt( a, 8 );
	}

void CBitBin :: PushChar( char ch ) { 
	FlushChar();
	EnsureSpace(1);
	m_pBuf[m_iBit/8]=ch;
	m_iBit+=8;
	}
	
void CBitBin :: PushBYTE( BYTE bt ) { 
	FlushChar();
	EnsureSpace(1);
	m_pBuf[m_iBit/8]=bt;
	m_iBit+=8;
	}

void CBitBin :: PushString( const char * pch, int iLen ) { 
	if( iLen==-1 )
		iLen=strlen(pch);

	FlushChar();
	EnsureSpace(iLen);
	memcpy( m_pBuf+m_iBit/8, pch, iLen );
	m_iBit += 8 * iLen;
	}
	
//---- return CString of bits loaded so far.	
void CBitBin :: GetQue( bool bClear, CString * pc ) { 
	pc->Set( (char *)m_pBuf, (m_iBit+7)/8 );
	if( bClear ) 
		m_iBit=0;
	}

//----- return byte length 	
int CBitBin :: GetLen( ){ 
	return (m_iBit+7)/8; 
	}

//----- return ptr to buffer
BYTE * CBitBin :: Buffer() { 
	return m_pBuf;
	}
	
//------------------------------------------------------------------------------------
//-- constructor 
CSWF :: CSWF( BYTE r, BYTE g, BYTE b ) { 
	m_iWid=m_iHgt=1;
	SetBGR( r, g, b );
	} 

//-- add Code and length tag to bitbin
void CSWF :: SetCodeLen( CBitBin * pBin, int iCode, int iLen ) { 
	short i;
	i = (iCode<<6) | min(iLen,63);
	pBin->PushString( (char *)(&i), 2 );
	if( iLen>=63 )
		pBin->PushString( (char *)(&iLen), 4 );
	}

//-- show Frame tag (id=1)
void CSWF :: ShowFrame( int iCount ) {		// aways byte aligned ? 
	for( int i=0; i<iCount; ++i ) 
		SetCodeLen( &m_oBin, 1, 0 );
	}

//-- End File tag (id=0)
void CSWF :: EndFile( ) { 
	SetCodeLen( &m_oBin, 0, 0 );
	}

//-- Set background tag (id=9)
void CSWF :: SetBGR( BYTE r, BYTE g, BYTE b ) { 	
	SetCodeLen( &m_oBin, 9, 3 );
	m_oBin.PushChar( r );
	m_oBin.PushChar( g );
	m_oBin.PushChar( b );
	}

//-- Tag 36 : Create SWF lossless Bitmap type 5 - RGBA array (Alpha.Blue.Green.Red)
void CSWF :: DefineBits5( int id, int iWid, int iHgt, BYTE * pImg ) { 
	CString c;
	ZLibCompress( pImg, iWid*iHgt*4, &c );	
	SetCodeLen( &m_oBin, 36, c.Length()+7 );
	//m_oBin.PushLong( 7+c.Length() );
	m_oBin.PushShort( id );				// bitmap index id
	m_oBin.PushBYTE( 5 );					// type 
	m_oBin.PushShort( iWid );				// width
	m_oBin.PushShort( iHgt );				// Length
	m_oBin.PushString( c.Buffer(), c.Length() );
	}

//----- SHAPEWITHSTYLE tag components

//-- 
void CSWF :: FillStyleBitmap( CBitBin * pBin, int iCharID, int iXPos, int iYPos ) { 
	pBin->PushChar( 0x41 );	// clipped bitmap fill (0x40=tiled 0x12=radial gradient 0x10=linear gradient 0x00=solid
	pBin->PushShort( iCharID );
	pBin->PushMtx( 1.0, 1.0, -1.0, -1.0, iXPos, iYPos );
	}
	
//--
void CSWF :: StyleElement( CBitBin * pBin, int iCode1, int iCode2, int iSize, bool bNeg ) { 
    int iBits = int(ceil(log2(iSize))) +1;
    pBin->PushInt( iCode1, 2 );			// '11'
    pBin->PushInt( iBits-2, 4 );
    pBin->PushInt( iCode2, 2 );			// '01'
    pBin->PushInt( (bNeg?-1:1)*iSize, iBits );
    }

void CSWF :: BitmapShapeWithStyle( CBitBin * pBin, int iCharID, int iX0, int iX1, int iY0, int iY1 ) { 
	//-- Fill Styles
	pBin->PushBYTE( 2 );
	FillStyleBitmap( pBin, 0x7FFF, iX0, iY0 );
	FillStyleBitmap( pBin, iCharID, iX0, iY0 );
	
    //--line Styles
	pBin->PushBYTE( 0 );
    
	//--Fill, line index bits = 2,0
	pBin->PushBYTE( 0x20 );
    
    //-- Style change - NEWSTYLE + EDGE + EDGE + EDGE + EDGE + END
    // type=0 newstyle=0 linestyle=0 fill1=1 fill0=0 move=1 + movesize[5] + dx[] + iDY[] + Fill1=2
	int iBits = int(ceil(log2(20.0*max(iX1,iY0))))+1;
	pBin->PushInt( 5, 6 );			// '000101'
	pBin->PushInt( iBits, 5);
	pBin->PushInt( iX1*20, iBits);
	pBin->PushInt( iY0*20, iBits);
	pBin->PushInt( 2, 2 );			// '10'
    
    //-- y=y+iDY : type=1(edge) straight=1 bits[4](add+2) general=0(V or H) 1(=Ver) iDY
    StyleElement( pBin, 3, 1, 20*(iY1-iY0), false );  // '11' iBits-2 '01' dY*20
    
    //-- x=x-iDX : type=1(edge) straight=1 bits[4](add+2) general=0(V or H) 0(=Hor) iDX
    StyleElement( pBin, 3, 0, 20*(iX1-iX0), true );
    
    //-- y=y-iDY 
    StyleElement( pBin, 3, 1, 20*(iY1-iY0), true );
    
    //-- x=x+iDX : type=1(edge) straight=1 bits[4](add+2) general=0(V or H) 0(=Hor) iDX
    StyleElement( pBin, 3, 0, 20*(iX1-iX0), false );
    
    //-- End Shape Record
    pBin->PushInt( 0, 6 );			// '000000'
	}

//--
void CSWF :: LineStyle( CBitBin * pBin, int iPixelWidth, BYTE r, BYTE g, BYTE b ) { 
	short i = 20 * iPixelWidth;
	pBin->PushShort( 20 * iPixelWidth );
	pBin->PushBYTE( r );
	pBin->PushBYTE( g );
	pBin->PushBYTE( b );
    }

//--
void CSWF :: RectangleShapeWithStyle( CBitBin * pBin, int iCharID, 
						int iX0, int iX1, int iY0, int iY1, 
						BYTE r, BYTE g, BYTE b )  { 
    //----- SHAPEWITHSTYLE tag contents
    // 0 Fill Styles, 1 line syle = 20/20 pixels blue, 0 fill index bits, 1 line index bit
    pBin->PushBYTE( 0 );
    pBin->PushBYTE( 1 );
    LineStyle( pBin, 1, r, g, b );
    pBin->PushBYTE( 1 );

    //-- Style change - NEW-LINE-STYLE&MOVE  + EDGE + EDGE + EDGE + EDGE + END
    // type=0 newstyle=0 linestyle=1 fill1=0 fill0=0 move=1 + movesize[5] + iDX[] + iDY[]
	int iBits = int(ceil(log2(20.0*max(iX1,iY0))))+1;
	pBin->PushInt( 9, 6 );			// '000101'
	pBin->PushInt( iBits, 5);
	pBin->PushInt( iX1*20, iBits);
	pBin->PushInt( iY0*20, iBits);
	pBin->PushInt( 1, 1 );			// '1'
    
    //--y=y+iDY : type=1(edge) straight=1 bits[4](add+2) general=0(V or H) 1(=Ver) iDY
    StyleElement( pBin, 3, 1, 20*(iY1-iY0), false );  // '11' iBits-2 '01' dY*20
    
    // x=x-iDX : type=1(edge) straight=1 bits[4](add+2) general=0(V or H) 0(=Hor) iDX
    StyleElement( pBin, 3, 0, 20*(iX1-iX0), true );

    // y=y-iDY 
    StyleElement( pBin, 3, 1, 20*(iY1-iY0), true );

    // x=x+iDX : type=1(edge) straight=1 bits[4](add+2) general=0(V or H) 0(=Hor) iDX
    StyleElement( pBin, 3, 0, 20*(iX1-iX0), false );
    
    //-- End Shape Record
    pBin->PushInt( 0, 6 );			// '000000'
    }

//-- 
void CSWF :: BitmapPlace( int iShapeID, int iCharID, int iX0, int iX1, int iY0, int iY1 ) { 
	CBitBin tmp;
	tmp.PushRct( 0, 20*iX0, 20*iX1, 20*iY0, 20*iY1 );
	BitmapShapeWithStyle( &tmp, iCharID, iX0, iX1, iY0, iY1 );
	CString cc;
	tmp.GetQue(false, &cc);

	SetCodeLen( &m_oBin, 2, cc.Length()+2 );		// Define Shape 
	m_oBin.PushShort( iShapeID );
	m_oBin.PushString( cc.Buffer(), cc.Length() );
	}
	
//-- 
/*
void CSWF :: RectanglePlace( int iShapeID, int iCharID, 
			int iX0, int iX1, int iY0, int iY1, BYTE r, BYTE g, BYTE b ) { 
	CBitBin tmp;
	tmp.PushRct( 0, 20*iX0, 20*iX1, 20*iY0, 20*iY1 );
	RectangleShapeWithStyle( &tmp, iCharID, iX0, iX1, iY0, iY1, r, g, b );
	
	SetCodeLen( pBin, 2, tmp.GetLen()+2 );		// Define Shape 
	m_oBin.PushInt( iShapeID, 16 );
	m_oBin.PushString( tmp.GetQue(false).Buffer(), tmp.GetLen() );
	}
*/

//-- Place a previously defined shape object 
void CSWF :: PlaceObject2( int iDepth, int iCharID ) { 
	SetCodeLen( &m_oBin, 26, 6 );
	m_oBin.PushBYTE( 6 );		// bits : reserved=128,reserved=64,HasName=32,HasRatio=16,HasColorTransform=8,HasMatrix=4,HasCharacter=2,Move=1
	m_oBin.PushShort( iDepth );
	m_oBin.PushShort( iCharID );
	m_oBin.PushBYTE( 0 );		// matrix
	}	

/*
//-- Move a previously placed shape object 
void CSWF :: MoveObject2( int iDepth, int iDX, int iDY ) { 
    //-- Rct must be 60 bytes max ( which it always is)
    CBitBin tmp;
    tmp.PushMtx( -1,-1,-1,-1,iDX,iDY );

    SetCodeLen( &m_oBin, 26, tmp.GetLen()+3 );
    m_oBin.PushBYTE(5);			// move=1, HasMatrix=4
	m_oBin.PushInt( iDepth, 16 );
	m_oBin.PushString( tmp.GetQue(false).Buffer(), tmp.GetLen() );
	}
*/

//-- Remove object at specified depth 
void CSWF :: RemoveObject2( int iDepth) { 
    SetCodeLen( &m_oBin, 28, 2 );
    m_oBin.PushShort( iDepth );
    }

//-- Construct file header
void CSWF :: Create( const char * pchFile, int iMaxWid, int iMaxHgt, BYTE iFrameRate, short iFrames ) { 
	m_iWid=iMaxWid;
	m_iHgt=iMaxHgt;
	CBitBin rct;									// Frame Size Rectangle
	rct.PushRct( 0, 0, 20*iMaxWid, 0, 20*iMaxHgt );

	m_h = fopen( pchFile, "wb+" );					// open file 
	
	fwrite( "FWS\x05", 4, 1, m_h);					// version 5 SWF
	
	m_iFileLen=12+rct.GetLen();						// entire file length
	fwrite( &m_iFileLen, 4, 1, m_h );	
	
	fwrite( rct.Buffer(), rct.GetLen(), 1, m_h );	// frame size in twips
	
	fwrite( "\x00", 1, 1, m_h );					// fraction of frames per second (0)
	fwrite( &iFrameRate, 1, 1, m_h );				// whole of frames per second
	
	fwrite( &iFrames, 2, 1, m_h );					// total frame count
	}

void CSWF :: Flush() { 
	if( m_oBin.GetLen()>0 ) { 
		fwrite( m_oBin.Buffer(), m_oBin.GetLen(), 1, m_h);// Main Write - file contents
		m_iFileLen+=m_oBin.GetLen();
		m_oBin.ClearQue();
		}
	}
	
void CSWF :: Close() { 
	EndFile( );										// add endfile tag to bin.
	Flush();
	fflush( m_h );
	int iErr = fseek( m_h, 4, SEEK_SET );						// replace file length at pos 4
	iErr = fwrite( &m_iFileLen, 4, 1, m_h );
	fclose( m_h );
	}

void CSWF :: BMPCopy( int iCharID, int iPlaceID, int iRows, int iCols, BYTE * pBmp ) { 
	int iWid=min(800,iCols);
	BYTE * pBuf = new BYTE[iRows*4*iWid];
	int iSrc, iDst;
	for( int iRow=0; iRow<iRows; ++iRow ) {
		for( int iCol=0; iCol<iWid; ++iCol ) {
			iSrc=((iRows-iRow-1)*iWid+iCol)*4;
			iDst=(iRow*iCols+iCol)*3;
			pBuf[iSrc]=255;
			pBuf[iSrc+1]=pBmp[iDst+2];
			pBuf[iSrc+2]=pBmp[iDst+1];
			pBuf[iSrc+3]=pBmp[iDst+0];
			}
		}
		
	DefineBits5( iCharID, iWid, iRows, pBuf );
	delete [] pBuf;
	
	BitmapPlace( iPlaceID, iCharID, 1, m_iWid+1, 1, m_iHgt+1 );
	
	}

void CSWF :: AddFrame( int iPlaceID, int iDepth ) { 			
	PlaceObject2( iDepth, iPlaceID );
	ShowFrame( 1 );
	RemoveObject2( iDepth );
	}
	
/*

void CSWF :: Go( int iFrames ) { 
	int iFrame, iID;
	
	//-- image definitions
	for( iFrame=1; iFrame<=iFrames; ++iFrame ) { 
		BMPCopy( iFrame, _iRows, _iCols, _pBits );
		m_iHgt = max( m_iHgt, iRows );
		m_iWid = max( m_iWid, min(800,iCols) );
		}

	//-- Frames 
	for( iFrame=1; iFrame<=iFrames; ++iFrame ) { 
		PlaceObject2( 1, iFrames+iFrame );
		ShowFrame( 1 );
        RemoveObject2( 1 );
        }

    SWFFile( cOutFile, iMaxWid, iMaxHgt, 12, iFrames, cSWF );
	}


*/
